/*-----------------------------------------------------------------------
  
  File        : tutorial.cpp

  Description : View the color profile of an image, along the X-axis
  
  Copyright  : David Tschumperle - http://www.greyc.ensicaen.fr/~dtschump/
  
  This software is governed by the CeCILL  license under French law and
  abiding by the rules of distribution of free software.  You can  use, 
  modify and/ or redistribute the software under the terms of the CeCILL
  license as circulated by CEA, CNRS and INRIA at the following URL
  "http://www.cecill.info". 
  
  As a counterpart to the access to the source code and  rights to copy,
  modify and redistribute granted by the license, users are provided only
  with a limited warranty  and the software's author,  the holder of the
  economic rights,  and the successive licensors  have only  limited
  liability. 
  
  In this respect, the user's attention is drawn to the risks associated
  with loading,  using,  modifying and/or developing or reproducing the
  software by the user in light of its specific status of free software,
  that may mean  that it is complicated to manipulate,  and  that  also
  therefore means  that it is reserved for developers  and  experienced
  professionals having in-depth computer knowledge. Users are therefore
  encouraged to load and test the software's suitability as regards their
  requirements in conditions enabling the security of their systems and/or 
  data to be ensured and,  more generally, to use and operate it in the 
  same conditions as regards security. 
  
  The fact that you are presently reading this means that you have had
  knowledge of the CeCILL license and that you accept its terms.
  
  ---------------------------------------------------------------------*/

#include <iostream>
#include <CImg.h>

using namespace std;
using namespace cimg_library;

int main(int argc,char **argv) {
  size_t dimx = 800;
  size_t dimy = 600;
  CImg<unsigned char> image(dimx,dimy,1,3);

/*  // grayscale image1
  for( size_t i = 0; i < image1.dimx(); i++ ) {
     for( size_t j = 0; j < image1.dimy(); j++ ) {
         int avg = 0;
         for( size_t c = 0; c < image1.dimv(); c++ )
             avg += image1(i,j,c);
         avg /= 3;
         for( size_t c = 0; c < image1.dimv(); c++ )
            image1(i,j,c) = avg;
     }
  }*/

  CImgDisplay main_disp(image,"Image",0);

//  image4.save_jpeg(file_p,100);

  while (!main_disp.is_closed)
    cimg::wait(40);

  return 0;
}
