# need a gnuplot 4.2 or higher (~/bin/gnuplot)
set terminal postscript eps enhanced monochrome

set size 0.5,0.5
set xtics 1e-9,1e3,1
set logscale x
unset logscale y
set xrange [0.5e-9:2]
set yrange [0:10]
set xlabel 'Gaps'
set ylabel 'instance'
set key off

# Gaps for PROMEDAS

set output 'eps/promedas_bp_talk.eps'
set title 'Belief Propagation'
plot 'dat/promedas_bp.dat' u ($5+1e-9):1 pt 5

set output 'eps/promedas_cav_talk.eps'
set title 'BoxProp-SubT'
plot 'dat/promedas_cav.dat' u ($5+1e-9):1 pt 5

set output 'eps/promedas_saw_talk.eps'
set title 'BoxProp-SAWT'
plot 'dat/promedas_saw.dat' u ($5+1e-9):1 pt 5

set output 'eps/promedas_boundprop_talk.eps'
set title 'BoundProp'
plot 'dat/promedas_boundprop.dat' u ($5+1e-9):1 pt 5

exit
