set terminal postscript eps enhanced color
set xlabel '{/Symbol b}'
set ylabel 'error'
set key below
set logscale y
set yrange [1e-9:2]
set logscale x
set data style lines

set output 'bounds1_error.eps'
set title 'Bounds on error of BP marginals : error for periodic 8x8 SG grid with {/Symbol s}_J = {/Symbol b}, {/Symbol s}_{/Symbol q} = {/Symbol b}'
plot 'bounds1.dat' u 1:2  title 'Tatikondas bound', \
     'bounds1.dat' u 1:3  title 'Actual BP error (min)', \
     'bounds1.dat' u 1:4  title 'Actual BP error (max)', \
     'bounds1.dat' u 1:7  title 'My bound (min)', \
     'bounds1.dat' u 1:8  title 'My bound (max)', \
     'bounds1.dat' u 1:11 title 'MF-TRWUNI (min)', \
     'bounds1.dat' u 1:12 title 'MF-TRWUNI (max)'

set output 'bounds2_error.eps'
set title 'Bounds on error of BP marginals : error for periodic 5x5 SG grid with {/Symbol s}_J = {/Symbol b}, {/Symbol s}_{/Symbol q} = {/Symbol b}'
plot 'bounds2.dat' u 1:2  title 'Tatikondas bound', \
     'bounds2.dat' u 1:3  title 'Actual BP error (min)', \
     'bounds2.dat' u 1:4  title 'Actual BP error (max)', \
     'bounds2.dat' u 1:7  title 'My bound (min)', \
     'bounds2.dat' u 1:8  title 'My bound (max)', \
     'bounds2.dat' u 1:11 title 'ex-TRWOPT(otol=1e-9) (min)', \
     'bounds2.dat' u 1:12 title 'ex-TRWOPT(otol=1e-9) (max)', \
     'bounds2.dat' u 1:15 title 'BoundProp(tol=1e-9,fast=0) (min)', \
     'bounds2.dat' u 1:16 title 'BoundProp(tol=1e-9,fast=0) (max)'

set output 'bounds3_error.eps'
set title 'Bounds on error of BP marginals : error for periodic 8x8 SG grid with {/Symbol s}_J = {/Symbol b}, {/Symbol s}_{/Symbol q} = {/Symbol b}'
plot 'bounds3.dat' u 1:2  title 'Tatikondas bound', \
     'bounds3.dat' u 1:4  title 'Actual BP error (min)', \
     'bounds3.dat' u 1:5  title 'Actual BP error (max)', \
     'bounds3.dat' u 1:9  title 'My bound (min)', \
     'bounds3.dat' u 1:10 title 'My bound (max)', \
     'bounds3.dat' u 1:14 title 'MF-ex (min)', \
     'bounds3.dat' u 1:15 title 'MF-ex (max)', \
     'bounds3.dat' u 1:19 title 'BoundProp(tol=1e-9,fast=0) (min)', \
     'bounds3.dat' u 1:20 title 'BoundProp(tol=1e-9,fast=0) (max)'
set output 'bounds3_time.eps'
set yrange [1e-2:*]
set ylabel 'Time (s)'
set title 'Time (s) to calculate the bounds for periodic 8x8 SG grid with {/Symbol s}_J = {/Symbol b}, {/Symbol s}_{/Symbol q} = {/Symbol b}'
plot 'bounds3.dat' u 1:($3/100.0)  title 'Tatikondas bound', \
     'bounds3.dat' u 1:($8/100.0)  title 'Actual BP error', \
     'bounds3.dat' u 1:($13/100.0) title 'My bound', \
     'bounds3.dat' u 1:($18/100.0) title 'MF-ex', \
     'bounds3.dat' u 1:($23/100.0) title 'BoundProp(tol=1e-9,fast=0)

set output 'bounds4_error.eps'
set title 'Marginal gaps : for periodic 8x8 SG grid with {/Symbol s}_J = {/Symbol b}, {/Symbol s}_{/Symbol q} = {/Symbol b}'
set yrange [1e-9:2]
set ylabel 'Gap'
plot 'bounds4.dat' u 1:2 title 'BP error (min)', \
    'bounds4.dat' u 1:3 title 'BP error (max)', \
    'bounds4.dat' u 1:7 title 'Dobrushin-Tatikonda', \
    'bounds4.dat' u 1:12 title 'Cavity (min)', \
    'bounds4.dat' u 1:13 title 'Cavity (max)', \
    'bounds4.dat' u 1:22 title 'LK-JJ (min)', \
    'bounds4.dat' u 1:23 title 'LK-JJ (max)'

#set output 'bounds5_error.eps'
#set title 'Marginal gaps : for periodic 5x5 SG grid with {/Symbol s}_J = {/Symbol b}, {/Symbol s}_{/Symbol q} = {/Symbol b}'
#set yrange [1e-9:2]
#set ylabel 'Gap'
#plot 'bounds5a.dat' u 1:2  title 'BP error (min)', \
#     'bounds5a.dat' u 1:3  title 'BP error (max)', \
#     'bounds5a.dat' u 1:7  title 'Dobrushin-Tatikonda', \
#     'bounds5a.dat' u 1:12 title 'Dobrushin-Taga-Mase (min)', \
#     'bounds5a.dat' u 1:13 title 'Dobrushin-Taga-Mase (max)', \
#     'bounds5a.dat' u 1:17 title 'Cavity (min)', \
#     'bounds5a.dat' u 1:18 title 'Cavity (max)', \
#     'bounds5a.dat' u 1:22 title 'LK-JJ (min)', \
#     'bounds5a.dat' u 1:23 title 'LK-JJ (max)', \
#     'bounds5a.dat' u 1:27 title 'BoundProp (min)', \
#     'bounds5a.dat' u 1:28 title 'BoundProp (max)', \
#     'bounds5b.dat' u 1:22 title 'MF-TRW (min)', \
#     'bounds5b.dat' u 1:23 title 'MF-TRW (max)'
#set output 'bounds5_time.eps'
#set title 'Time (s) to calculate the bounds for periodic 5x5 SG grid with {/Symbol s}_J = {/Symbol b}, {/Symbol s}_{/Symbol q} = {/Symbol b}'
#set yrange [1e-2:*]
#set ylabel 'Time (s)'
#plot 'bounds5a.dat' u 1:($11/100.0) title 'Dobrushin-Tatikonda', \
#     'bounds5a.dat' u 1:($16/100.0) title 'Dobrushin-Taga-Mase', \
#     'bounds5a.dat' u 1:($21/100.0) title 'Cavity', \
#     'bounds5a.dat' u 1:($26/100.0) title 'LK-JJ', \
#     'bounds5a.dat' u 1:($31/100.0) title 'BoundProp', \
#     'bounds5b.dat' u 1:($26/100.0) title 'MF-TRW'




set terminal postscript eps enhanced monochrome
set size 0.6,0.6
set xlabel '{/Symbol b}'
set ylabel 'gap'
set key below
set logscale x
set logscale y
set yrange [1e-9:2]
set title ''
set output 'bounds5a_error.eps'
plot 'bounds5a.dat' u 1:3  title 'Max BP error' with lines, \
     'bounds5a.dat' u 1:7  title 'DT' with lines lt 3, \
     'bounds5a.dat' u 1:14:12:13 title 'DTM' with errorlines lt 2, \
     'bounds5a.dat' u 1:19:17:18 title 'BoxProp' with errorlines pt 5
set output 'bounds5b_error.eps'
plot 'bounds5a.dat' u 1:3    title 'Max BP error' with lines, \
     'bounds5a.dat' u 1:24:22:23 title 'LK3-JJ' with errorlines lt 3, \
     'bounds5b.dat' u 1:24:22:23 title 'MF-TRW' with errorlines lt 2, \
     'bounds5a.dat' u 1:19:17:18 title 'BoxProp' with errorlines pt 5
set output 'bounds5c_error.eps'
plot 'bounds5a.dat' u 1:3    title 'Max BP error' with lines, \
     'bounds5a.dat' u 1:29:27:28 title 'BoundProp' with errorlines lt 3, \
     'bounds5a.dat' u 1:19:17:18 title 'BoxProp' with errorlines pt 5
set output 'bounds5_time.eps'
set yrange [1e-2:*]
set ylabel 'Time (s)'
set data style linespoints
plot 'bounds5a.dat' u 1:($21/100.0) title 'BoxProp', \
     'bounds5a.dat' u 1:($26/100.0) title 'LK3-JJ', \
     'bounds5a.dat' u 1:($31/100.0) title 'BoundProp', \
     'bounds5b.dat' u 1:($26/100.0) title 'MF-TRW'
