set terminal postscript eps enhanced color
set xlabel '{/Symbol b}'
set key below
set logscale x
set data style lines

set output 'trw1_error.eps'
set ylabel 'error'
set logscale y
set yrange [1e-9:*]
set title 'logZ error of various methods for periodic 5x5 SG grid with {/Symbol s}_J = {/Symbol b}, {/Symbol s}_{/Symbol q} = {/Symbol b}'
plot 'trw1.dat' u 1:(-$3) title 'MF', \
     'trw1.dat' u 1:6 title 'TRW UNI', \
     'trw1.dat' u 1:9 title 'TRW OPT otol=1e-3'

set output 'trw1_time.eps'
set ylabel 'time'
set logscale y
set yrange [0.01:*]
set title 'Time in s for various methods for periodic 5x5 SG grid with {/Symbol s}_J = {/Symbol b}, {/Symbol s}_{/Symbol q} = {/Symbol b}'
plot 'trw1.dat' u 1:($2/100.0) title 'MF', \
     'trw1.dat' u 1:($5/100.0) title 'TRW UNI', \
     'trw1.dat' u 1:($8/100.0) title 'TRW OPT otol=1e-3'

set output 'trw2_error.eps'
set ylabel 'error'
set logscale y
set yrange [1e-9:*]
set title 'logZ error of various methods for periodic 5x5 SG grid with {/Symbol s}_J = {/Symbol b}, {/Symbol s}_{/Symbol q} = {/Symbol b}'
plot 'trw2.dat' u 1:(-$3) title 'MF', \
     'trw2.dat' u 1:6 title 'TRW UNI', \
     'trw2.dat' u 1:9 title 'TRW OPT otol=1e-3', \
     'trw2.dat' u 1:12 title 'TRW OPT otol=1e-9'

set output 'trw2_time.eps'
set ylabel 'time'
set logscale y
set yrange [0.01:*]
set title 'Time in s for various methods for periodic 5x5 SG grid with {/Symbol s}_J = {/Symbol b}, {/Symbol s}_{/Symbol q} = {/Symbol b}'
plot 'trw2.dat' u 1:($2/100.0) title 'MF', \
     'trw2.dat' u 1:($5/100.0) title 'TRW UNI', \
     'trw2.dat' u 1:($8/100.0) title 'TRW OPT otol=1e-3', \
     'trw2.dat' u 1:($11/100.0) title 'TRW OPT otol=1e-9'

set output 'trw3_error.eps'
set ylabel 'error'
set logscale y
set yrange [1e-12:1e3]
set title 'logZ error of various methods for periodic 5x5 SG grid with {/Symbol s}_J = {/Symbol b}, {/Symbol s}_{/Symbol q} = {/Symbol b}'
plot '/tmp/trw.dat' u 1:(-$3) title 'MF', \
     '/tmp/trw.dat' u 1:6 title 'TRW UNI', \
     '/tmp/trw.dat' u 1:9 title 'TRW OPT otol=1e-3', \
     '/tmp/trw.dat' u 1:12 title 'TRW OPT otol=1e-9', \
     '/tmp/trw.dat' u 1:15 title 'JJ', \
     '/tmp/trw.dat' u 1:17 title 'JJ-opt', \
     '/tmp/trw.dat' u 1:(-$19) title 'LK', \
     '/tmp/trw.dat' u 1:(-$21) title 'LK-opt'

set output 'trw3_time.eps'
set ylabel 'time'
set logscale y
set yrange [0.01:*]
set title 'Time in s for various methods for periodic 5x5 SG grid with {/Symbol s}_J = {/Symbol b}, {/Symbol s}_{/Symbol q} = {/Symbol b}'
plot '/tmp/trw.dat' u 1:($2/100.0) title 'MF', \
     '/tmp/trw.dat' u 1:($5/100.0) title 'TRW UNI', \
     '/tmp/trw.dat' u 1:($8/100.0) title 'TRW OPT otol=1e-3', \
     '/tmp/trw.dat' u 1:($11/100.0) title 'TRW OPT otol=1e-9', \
     '/tmp/trw.dat' u 1:($14/100.0) title 'JJ', \
     '/tmp/trw.dat' u 1:($16/100.0) title 'JJ-opt', \
     '/tmp/trw.dat' u 1:($18/100.0) title 'LK', \
     '/tmp/trw.dat' u 1:($20/100.0) title 'LK-opt'
