#include <iostream>
#include <sstream>
#include <fstream>
#include <string>
#include <algorithm>
#include "factorgraph.h"
#include "exceptions.h"
#include "bounds.h"


using namespace std;
using namespace libDAI;


/*
std::istream& operator >> (std::istream& is, FactorGraph& fg) {
    long verbose = 0;

    try {
        vector<Factor> factors;
        size_t nr_f;
        string line;
        
        while( (is.peek()) == '#' )
            getline(is,line);
        is >> nr_f;
        if( is.fail() )
            DAI_THROW(INVALID_FACTORGRAPH_FILE);
        if( verbose >= 2 )
            cout << "Reading " << nr_f << " factors..." << endl;

        getline (is,line);
        if( is.fail() )
            DAI_THROW(INVALID_FACTORGRAPH_FILE);

        for( size_t I = 0; I < nr_f; I++ ) {
            if( verbose >= 3 )
                cout << "Reading factor " << I << "..." << endl;
            size_t nr_members;
            while( (is.peek()) == '#' )
                getline(is,line);
            is >> nr_members;
            if( verbose >= 3 )
                cout << "  nr_members: " << nr_members << endl;

            vector<long> labels;
            for( size_t mi = 0; mi < nr_members; mi++ ) {
                long mi_label;
                while( (is.peek()) == '#' )
                    getline(is,line);
                is >> mi_label;
                labels.push_back(mi_label);
            }
            if( verbose >= 3 ) {
                cout << "  labels: ";
                copy (labels.begin(), labels.end(), ostream_iterator<int>(cout, " "));
                cout << endl;
            }

            vector<size_t> dims;
            for( size_t mi = 0; mi < nr_members; mi++ ) {
                size_t mi_dim;
                while( (is.peek()) == '#' )
                    getline(is,line);
                is >> mi_dim;
                dims.push_back(mi_dim);
            }
            if( verbose >= 3 ) {
                cout << "  dimensions: ";
                copy (dims.begin(), dims.end(), ostream_iterator<int>(cout, " "));
                cout << endl;
            }

            // add the Factor
            VarSet I_vars;
            for( size_t mi = 0; mi < nr_members; mi++ )
                I_vars |= Var(labels[mi], dims[mi]);
            factors.push_back(Factor(I_vars,0.0));
            
            // calculate permutation sigma (internally, members are sorted)
            vector<long> sigma(nr_members,0);
            VarSet::iterator j = I_vars.begin();
            for( size_t mi = 0; mi < nr_members; mi++,j++ ) {
                long search_for = j->label();
                vector<long>::iterator j_loc = find(labels.begin(),labels.end(),search_for);
                sigma[mi] = j_loc - labels.begin();
            }
            if( verbose >= 3 ) {
                cout << "  sigma: ";
                copy( sigma.begin(), sigma.end(), ostream_iterator<int>(cout," "));
                cout << endl;
            }

            // calculate multindices
            vector<size_t> sdims(nr_members,0);
            for( size_t k = 0; k < nr_members; k++ ) {
                sdims[k] = dims[sigma[k]];
            }
            multind mi(dims);
            multind smi(sdims);
            if( verbose >= 3 ) {
                cout << "  mi.max(): " << mi.max() << endl;
                cout << "       ";
                for( size_t k=0; k < nr_members; k++ ) 
                    cout << labels[k] << " ";
                cout << "   ";
                for( size_t k=0; k < nr_members; k++ ) 
                    cout << labels[sigma[k]] << " ";
                cout << endl;
            }
            
            // read values
            size_t nr_nonzeros;
            while( (is.peek()) == '#' )
                getline(is,line);
            is >> nr_nonzeros;
            if( verbose >= 3 ) 
                cout << "  nonzeroes: " << nr_nonzeros << endl;
            for( size_t k = 0; k < nr_nonzeros; k++ ) {
                size_t li;
                double val;
                while( (is.peek()) == '#' )
                    getline(is,line);
                is >> li;
                while( (is.peek()) == '#' )
                    getline(is,line);
                is >> val;

                vector<size_t> vi = mi.vi(li);
                vector<size_t> svi(vi.size(),0);
                for( size_t k = 0; k < vi.size(); k++ )
                    svi[k] = vi[sigma[k]];
                size_t sli = smi.li(svi);
                if( verbose >= 3 ) {
                    cout << "    " << li << ": ";
                    copy( vi.begin(), vi.end(), ostream_iterator<size_t>(cout," "));
                    cout << "-> ";
                    copy( svi.begin(), svi.end(), ostream_iterator<size_t>(cout," "));
                    cout << ": " << sli << endl;
                }
                factors.back()[sli] = val;
            }
        }

        if( verbose >= 3 ) {
            cout << "factors:" << endl;
            copy(factors.begin(), factors.end(), ostream_iterator<Factor>(cout,"\n"));
        }

        fg = FactorGraph(factors);
    } catch (char *e) {
        cout << e << endl;
    }

    return is;
}*/


/*
void FactorGraph::ReadFromFile( const char *filename ) {
    ifstream infile;
    infile.open( filename );
    if( infile.is_open() ) {
        try { // FIXME: no exceptions are generated by iostreams by default
            infile >> *this;
            infile.close();
        } catch (...) {
            infile.close();
            throw;
        }
    } else
        DAI_THROW(CANNOT_READ_FILE);
}*/


struct keesvar {
    int individu;
    int merker;
    int type;

    keesvar( int _individu, int _merker, int _type ) : individu(_individu), merker(_merker), type(_type) {};

/*    bool operator <  (const Var& n) const { return( _label <  n._label ); };
    bool operator >  (const Var& n) const { return( _label >  n._label ); };
    bool operator <= (const Var& n) const { return( _label <= n._label ); };
    bool operator >= (const Var& n) const { return( _label >= n._label ); };*/
    bool operator <  (const keesvar& n) const { return(  (individu <  n.individu) || 
                                                        ((individu == n.individu) && (merker <  n.merker)) || 
                                                        ((individu == n.individu) && (merker == n.merker) && (type < n.type)) ); }
    bool operator == (const keesvar& n) const { return( individu == n.individu && merker == n.merker && type == n.type ); }
//    bool operator != (const keesvar& n) const { return !( *this == n ); }

    friend std::ostream& operator << (std::ostream& os, const keesvar& n) {
        return( os << "[" << n.individu << "," << n.merker << "," << n.type << "]" );
    }
};




int main( int argc, char *argv[] ) {
    if( argc != 3 ) {
        cout << "Usage: " << argv[0] << " <in.potnz> <out.fg>" << endl;
        return 1;
    } else {
        char *infile = argv[1];
        char *outfile = argv[2];
        size_t verbose = 0;
        ifstream instream;

        instream.open( infile );
        if( instream.is_open() ) {
            if( verbose ) 
                cout << "Reading " << argv[1] << "..." << endl;
            string line;
            size_t nr_lines = 0;
            map<keesvar,int> var_id;
            vector<Factor> factors;
            do {
                getline(instream,line);
                if( !instream.fail() ) {
                    istringstream linestream;
                    linestream.str(line);
                    int N_i, M_i;
                    linestream >> N_i;  // number of variables in potential psi_i
                    linestream >> M_i;  // number of nonzero entries of potential psi_i
                    vector<int> var_ids;
                    vector<size_t> var_dims;
                    for( int j = 0; j < N_i; j++ ) { // read variable id's
                        int v_individu, v_merker, v_type;
                        linestream >> v_individu;
                        linestream >> v_merker;
                        linestream >> v_type;
                        keesvar v( v_individu, v_merker, v_type );
                        map<keesvar,int>::const_iterator v_it = var_id.find( v );
                        int id = -1;
                        if( v_it == var_id.end() ) {
                            id = var_id.size();
                            var_id[v] = id;  // add new keesvar
                        } else { // it already exists
                            id = v_it->second;
                        }
                        var_ids.push_back( id );
                        if( v_type == 1 || v_type == 2 )
                            var_dims.push_back( 3 );
                        else if( v_type == 3 || v_type == 4 )
                            var_dims.push_back( 2 );
                        else {
                            cerr << "Wrong assumption" << endl;
                            return 3;
                        }
                        // var_ids contains the variable ids for psi_i
                        // var_dims the dimensions of the corresponding variables
                    }

                    // verbose diagnostics
                    if( verbose >= 2 ) {
                        cout << "Potential " << nr_lines << " depends on vars ";
                        for( int j = 0; j < N_i; j++ )
                            cout << var_ids[j] << " ";
                        cout << endl;
                    }

                    // add the Factor
                    VarSet psi_vars;
                    for( int j = 0; j < N_i; j++ )
                        psi_vars += Var(var_ids[j], var_dims[j]);
                    factors.push_back(Factor(psi_vars,0.0));
            
                    // calculate permutation sigma (internally, members are sorted)
                    // sigma[j] is the external index of variable with rank j (in the internal sorted list)
                    // so sigma[0] is the smallest variable, sigma[1] is the next-to-smallest, etc.
                    vector<size_t> sigma(N_i,0);
                    VarSet::iterator l = psi_vars.begin();
                    for( int j = 0; j < N_i; j++,l++ ) {
                        int search_for = l->label();
                        vector<int>::iterator l_loc = find(var_ids.begin(), var_ids.end(), search_for);
                        assert( l_loc != var_ids.end() );
                        sigma[j] = l_loc - var_ids.begin();
                    }
                    if( verbose >= 2 ) {
                        cout << "Permutation: ";
                        for( int j = 0; j < N_i; j++ )
                            cout << sigma[j] << " ";
                        cout << endl;
                    }

                    // read nonzero potential entries
                    for( int k = 0; k < M_i; k++ ) {
                        int v_state;
                        double value;
                        vector<size_t> vi(N_i,0);       // external vector index
                        for( int j = 0; j < N_i; j++ ) {
                            linestream >> v_state;
                            vi[j] = v_state;
                        }
                        // convert permuted vector index to linear index
                        size_t prod = 1;
                        size_t sli = 0;
                        for( int j = 0; j < N_i; j++ ) {
                            sli += vi[sigma[j]] * prod;
                            prod *= var_dims[sigma[j]];
                        }
                        linestream >> value;

                        factors.back()[sli] = value;
                    }
                    nr_lines++;
                }
            } while( !instream.fail() );
            if( verbose ) {
                cout << "Read " << nr_lines << " lines." << endl;
                cout << "Encountered " << var_id.size() << " unique variables." << endl;
            }
            instream.close();

            FactorGraph fg( factors );
            fg.WriteToFile( outfile );

            bool useIhler = false;
//            bool useSAW = true;
            size_t maxnodes = 10000;
            vector<Box> results;
            vector<Factor> bp_beliefs;
            results.reserve( fg.nrVars() );
            for( size_t i = 0; i < fg.nrVars(); i++ ) {
                if( fg.var(i).states() == 3 ) {
                    cout << i;

                    BoundTree bt;
                    bt.buildTree( fg, fg.var(i), maxnodes, false );
                    Box b = bt.BoxProp( fg, useIhler, 0, bp_beliefs );
                    cout << " " << b.max()[2] - b.min()[2];
                    
                    BoundTree bt2;
                    bt2.buildTree( fg, fg.var(i), maxnodes, true );
                    Box b2 = bt2.BoxProp( fg, useIhler, 0, bp_beliefs );
                    cout << " " << b2.max()[2] - b2.min()[2];
                    
                    cout << endl;
                    //cout << b << endl;
                }
            }

            return 0;
        } else {
            cerr << "Cannot open file " << infile << endl;
            return 2;
        }
    }

    return 0;
}
