#!/usr/bin/python

# averages all rows with the same value in the first column in the log-domain
# considers NANs as missing data

import math
import sys
import re
a = sys.stdin.readlines()

keys = []
avgs = []
nrs = []

for b in a:
    if b[0] != '#':
        z = re.split(r'\s+', b)
        y = []
        for i in z:
            if i != '':
                y.append(i)
        key = y[0]
        vals = y[1:]
        if not key in keys:
            avg = []
            nr = []
            for x in vals:
                if (float(x) == 0) or (str(float(x)) == 'nan'):
                    avg.append(0)
                    nr.append(0)
                else:
                    lx = math.log(float(x))
                    avg.append(lx)
                    nr.append(1)
            keys.append(key)
            avgs.append(avg)
            nrs.append(nr)
        else:
            ind = keys.index(key)
            for i in range(0,len(vals)):
                x = vals[i]
                if not ((float(x) == 0.0) or (str(float(x)) == 'nan')):
                    try:
                        lx = math.log(float(x))
                    except OverflowError:
                        print >> sys.stderr, "OverflowError reading " + x
                        raise
                    except:
                        print >> sys.stderr, "Error reading " + x
                        raise
                    avgs[ind][i] = avgs[ind][i] + lx
                    nrs[ind][i] = nrs[ind][i] + 1

for ind in range(0,len(keys)):
    key = keys[ind]
    print key,
    for i in range(0,len(avgs[ind])):
        if nrs[ind][i] == 0:
            print 'nan',
        else:
            print math.exp(avgs[ind][i] / nrs[ind][i]),
    print
print
