#!/usr/bin/python
import sys
import re
sys.path.append('/home/snn/jorism/PyX-0.9')
sys.path.append('/home/jorism/PyX-0.9')
from pyx import *
if len(sys.argv) != 5:
    print "Usage: plot.py in.dat in.avg out.pdf title"
else:
    c = canvas.canvas()

    methods = graph.data.file(sys.argv[1]).columns.keys()

    par = ''
    if 'N' in methods:
        par = 'N'
        partit = '$N$'
        parxaxis = graph.axis.linear(title=partit)
    elif 'sth' in methods:
        par = 'sth'
        partit = r'$\sigma_\theta$'
        parxaxis = graph.axis.log(title=partit)
    elif 'beta' in methods:
        par = 'beta'
        partit = r'$\beta$'
        parxaxis = graph.axis.log(title=partit)
    else:
        print "in.dat should contain a column with key 'N' or 'sth' or 'beta'"
        raise Exception

    gwidth  = 8
    gxspace = 3
    gheight = 8
    gyspace = 2
    xmax    = 30

    g = {}
    g['me'] = c.insert(graph.graphxy(width=gwidth, ratio=1, ypos=0, xpos=0, x=parxaxis, y=graph.axis.log(title="Max Err",min=1e-9,max=1)))
    g['ae'] = c.insert(graph.graphxy(width=gwidth, ratio=1, ypos=0, xpos=gwidth+gxspace, x=parxaxis, y=graph.axis.log(title="Avg Err",min=1e-9,max=1)))
    g['t'] = c.insert(graph.graphxy(width=gwidth, ratio=1, ypos=0, xpos=2*(gwidth+gxspace), x=parxaxis, y=graph.axis.log(title="clocks",min=1)))
    g['c'] = c.insert(graph.graphxy(width=gwidth, ratio=1, ypos=0, xpos=3*(gwidth+gxspace), x=parxaxis, y=graph.axis.linear(title="percentage convergence",min=0,max=1)))
    g['z'] = c.insert(graph.graphxy(width=gwidth, ratio=1, ypos=-gheight-gyspace, xpos=3*(gwidth+gxspace), x=parxaxis, y=graph.axis.log(title="relative logZ error",min=1e-9,max=1e9)))

    scatters = [['meBP_SEQMAX',            'meTREEEP'],
                ['meBP_SEQMAX',            'meLCBP_FULLCAV_SEQFIX'],
                ['meTREEEP',               'meLCBP2_PAIRCAV_SEQFIX'],
                ['meLCBP_PAIRCAV_SEQFIX',  'meLCBP2_PAIRCAV_SEQFIX'],
                ['meLCBP2_PAIRCAV_SEQFIX', 'meMR_RESPPROP_FULL'],
                ['meLCBPI_FULLCAV_SEQFIX', 'meLCBP_FULLCAV_SEQFIX'],
                ['meBP_SEQMAX',            'meLCBPI_FULLCAV_SEQFIX'],
                ['meBP_SEQMAX',            'meLCBPJ_FULLCAV_SEQFIX'],
                ['meBP_SEQMAX',            'meLCBPK_FULLCAV_SEQFIX'],
                ['meBP_SEQMAX',            'meLCBPL_FULLCAV_SEQFIX'],
                ['meBP_SEQMAX',            'meHAK_LOOP4'],
                ['meBP_SEQMAX',            'meMR_RESPPROP_FULL'],
                ['meBP_SEQMAX',            'meMR_RESPPROP_LINEAR'],
                ['meBP_SEQMAX',            'meMR_CLAMPING_FULL'],
                ['meBP_SEQMAX',            'meMR_CLAMPING_LINEAR'],
                ['meBP_SEQMAX',            'meMR_EXACT_FULL'],
                ['meBP_SEQMAX',            'meMR_EXACT_LINEAR'],
                ['meLCBPJ_FULLCAV_SEQFIX', 'meLCBP_FULLCAV_SEQFIX'],
                ['meLCBPJ_FULLCAV_SEQFIX', 'meLCBPI_FULLCAV_SEQFIX'],
                ['meLCBPK_FULLCAV_SEQFIX', 'meLCBP_FULLCAV_SEQFIX'],
                ['meLCBPK_FULLCAV_SEQFIX', 'meLCBPI_FULLCAV_SEQFIX'],
                ['meLCBPL_FULLCAV_SEQFIX', 'meLCBP_FULLCAV_SEQFIX'],
                ['meLCBPL_FULLCAV_SEQFIX', 'meLCBPI_FULLCAV_SEQFIX'],
                ['meLCBPK_FULLCAV_SEQFIX', 'meLCBPL_FULLCAV_SEQFIX'],
                ['meMR_CLAMPING_FULL',     'meMR_CLAMPING_LINEAR'],
                ['meMR_RESPPROP_FULL',     'meMR_RESPPROP_LINEAR'],
                ['meMR_CLAMPING_FULL',     'meMR_RESPPROP_FULL'],
                ['meLCBPK_UNICAV_SEQFIX',  'meHAK_MIN'],
                ['meHAK_MIN',              'meBP_SEQMAX'],
                ['meLCBP_PAIRCAV_SEQFIX',  'meLCBP_PAIR2CAV_SEQFIX']]

    methopts = {'BP_SEQMAX':                      ['BP', color.cmyk.Yellow, style.linestyle.solid, style.linewidth.thick],
                'TREEEP':                         ['TREEEP', color.rgb.green, style.linestyle.solid, style.linewidth.thick],
                'LCBP_FULLCAV_SEQFIX':            ['LCBP${}^-$-FULL', color.rgb.blue, style.linestyle.solid, style.linewidth.thick],
                'LCBP_PAIRCAV_SEQFIX':            ['LCBP${}^-$-PAIR', color.cmyk.Brown, style.linestyle.solid, style.linewidth.thick], 
                'LCBP_PAIR2CAV_SEQFIX':           ['LCBP${}^-$-PAIR2', color.cmyk.Brown, style.linestyle.dotted, style.linewidth.thick], 
                'LCBPI_FULLCAV_SEQFIX':           ['LCBP${}^+$-FULL', color.cmyk.Black, style.linestyle.solid, style.linewidth.thick], 
                'LCBPI_PAIRCAV_SEQFIX':           ['LCBP${}^+$-PAIR', color.cmyk.Tan, style.linestyle.solid, style.linewidth.thick], 
                'LCBPJ_FULLCAV_SEQFIX':           ['LCBP${}^*$-FULL', color.rgb.red, style.linestyle.solid, style.linewidth.thick],
                'LCBPJ_PAIRCAV_SEQFIX':           ['LCBP${}^*$-PAIR', color.rgb.red, style.linestyle.dotted, style.linewidth.thick],
                'LCBPK_FULLCAV_SEQFIX':           ['LCBP${}^{HOI-}$-FULL', color.cmyk.Purple, style.linestyle.solid, style.linewidth.thick],
                'LCBPL_FULLCAV_SEQFIX':           ['LCBP${}^{HOI+}$-FULL', color.cmyk.Cyan, style.linestyle.solid, style.linewidth.thick],
                'LCBPK_UNICAV_SEQFIX':            ['LCBP${}^{HOI-}$-UNI', color.cmyk.Gray, style.linestyle.solid, style.linewidth.thick],
                'HAK_MIN':                        ['HAK-MIN', color.cmyk.Black, style.linestyle.solid, style.linewidth.thick],
                'HAK_LOOP4':                      ['HAK-LOOP4', color.cmyk.Purple, style.linestyle.solid, style.linewidth.thick], 
                'GBP_LOOP4':                      ['GBP-LOOP4', color.cmyk.Purple, style.linestyle.dotted, style.linewidth.thick], 
                'HAK_LOOP6':                      ['HAK-LOOP6', color.cmyk.Orange, style.linestyle.solid, style.linewidth.thick], 
                'GBP_LOOP6':                      ['GBP-LOOP6', color.cmyk.Orange, style.linestyle.dotted, style.linewidth.thick], 
                'HAK_DELTA':                      ['HAK-$\Delta$', color.cmyk.Cyan, style.linestyle.solid, style.linewidth.thick], 
                'GBP_DELTA':                      ['GBP-$\Delta$', color.cmyk.Cyan, style.linestyle.dotted, style.linewidth.thick], 
                'LCBP2_PAIRCAV_SEQFIX':           ['LCBP-2', color.cmyk.Orange, style.linestyle.solid, style.linewidth.thick], 
                'LCBP_FULLCAV_NONE':              ['LCBP-init', color.cmyk.Magenta, style.linestyle.solid, style.linewidth.thick], 
#               'MR':                             ['LCBP-LR', color.cmyk.Gray, style.linestyle.solid, style.linewidth.thick], 
                'MR_RESPPROP_FULL':               ['LCBP-CUM-LR', color.cmyk.Gray, style.linestyle.solid, style.linewidth.thick], 
                'MR_RESPPROP_LINEAR':             ['LCBP-CUM-LR-lin', color.cmyk.Gray, style.linestyle.solid, style.linewidth.thin], 
                'MR_CLAMPING_FULL':               ['LCBP-CUM-CLAMP', color.cmyk.Gray, style.linestyle.dotted, style.linewidth.thick], 
                'MR_CLAMPING_LINEAR':             ['LCBP-CUM-CLAMP-lin', color.cmyk.Gray, style.linestyle.dotted, style.linewidth.thin],
                'MR_EXACT_FULL':                  ['LCBP-CUM-EXACT', color.cmyk.Gray, style.linestyle.dashed, style.linewidth.thick],
                'MR_EXACT_LINEAR':                ['LCBP-CUM-EXACT-lin', color.cmyk.Gray, style.linestyle.dashed, style.linewidth.thin],
                'JTREE_HUGIN':                    ['JUNCTIONTREE', color.cmyk.Black, style.linestyle.solid, style.linewidth.thick]}

    for m in methopts.keys():
        for y in ['me','ae','t','z']:
            if (y != 'z') or ((y == 'z') and (m[0:4] != 'LCBP') and (m[0:2] != 'MR')):
                if (y + m) in methods:
                    g[y].plot(graph.data.file(sys.argv[2],
                              x=par,
                              y=(y + m),title=methopts[m][0]),
                              styles=[graph.style.line([methopts[m][1], methopts[m][2], methopts[m][3]])])
        if ('c' + m) in methods:
            g['c'].plot(graph.data.file(sys.argv[2],
                        x=par,
                        y="log(c" + m + ")",title=methopts[m][0]),
                        styles=[graph.style.line([methopts[m][1], methopts[m][2], methopts[m][3]])])
            
    xpos=g['c'].xpos + gwidth + 2
    ypos=g['c'].ypos + g['c'].height
    tit = re.sub(r'_', r'\_', sys.argv[4])
    c.text(xpos,ypos,tit,[text.halign.left, text.valign.top])
    ypos = ypos - 1.0
    tits=[]
    for m in methopts.keys():
        if ('t' + m) in methods:
            c.stroke(path.line(xpos, ypos, xpos+1, ypos), [methopts[m][1], methopts[m][2], methopts[m][3]])
            c.text(xpos+2, ypos, methopts[m][0], [text.halign.left, text.valign.middle])
            ypos = ypos - 0.6
            
            
    gs = []
    xpos = 0
    ypos = -gheight - gyspace
    for sc in scatters:
        if (sc[0] in methods) and (sc[1] in methods):
            prop0 = sc[0].rstrip("ABCDEFGHIJKLMNOPQRSTUVWXYZ_0123456789")
            prop1 = sc[1].rstrip("ABCDEFGHIJKLMNOPQRSTUVWXYZ_0123456789")
            meth0 = sc[0].lstrip("abcdefghijklmnopqrstuvwxyz")
            meth1 = sc[1].lstrip("abcdefghijklmnopqrstuvwxyz")
            newg = c.insert(graph.graphxy(width=gwidth, ratio=1, xpos=xpos, ypos=ypos, x=graph.axis.log(min=1e-9,max=1,title=prop0 + methopts[meth0][0]), y=graph.axis.log(min=1e-9,max=1,title=prop1 + methopts[meth1][0])))
            # exercise: only plot points for which 'md' + meth0 is smaller than 1e-9
#            newg.plot(graph.data.file(sys.argv[1], x="((sgn(md" + meth0 + "-1.0001e-9)+1)/2)*1e5 + " + sc[0], y="((sgn(md" + meth1 + "-1.0001e-9)+1)/2)*1e5 + " + sc[1]), [graph.style.symbol(graph.style.symbol.circle, symbolattrs=[deco.filled])])
            newg.plot(graph.data.file(sys.argv[1], x=sc[0], y=sc[1]), [graph.style.symbol(graph.style.symbol.circle, symbolattrs=[deco.filled], size=.1)])
            newg.plot(graph.data.function("y(x) = x"), styles=[graph.style.line([color.rgb.red, style.linestyle.solid, style.linewidth.thick])])
            newg.plot(graph.data.function("y(x) = x*x"), styles=[graph.style.line([color.rgb.red, style.linestyle.dotted, style.linewidth.thick])])
            gs.append(newg)
            xpos = xpos + gwidth + gxspace
            if xpos > xmax:
                xpos = 0
                ypos = ypos - gheight - gyspace

    c.writePDFfile(sys.argv[3])
