/*  Copyright (C) 2006,2007  Joris Mooij  [joris at jorismooij dot nl]
    Radboud University Nijmegen, The Netherlands
    
    This file is part of libDAI.

    libDAI is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    libDAI is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with libDAI; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


#include "factorgraph.h"
#include <iostream>
#include <stdlib.h>


using namespace std;
using namespace libDAI;


int main( int argc, char *argv[] ) {
    if( argc != 5 ) {
        cout << "Usage: " << argv[0] << " <in.fg> <out.fg> <varindex> <varstate>" << endl << endl;
        cout << "Clamps variable <varindex> to its <varstate>'th state and writes" << endl;
        cout << "corresponding factor graph to <out.fg>." << endl;
        return 1;
    } else {
        char *infile = argv[1];
        char *outfile = argv[2];
        size_t i = atoi(argv[3]);
        size_t x_i = atoi(argv[4]);

        // Read factorgraph
        FactorGraph fg;
        fg.ReadFromFile( infile );

        FactorGraph clamped = fg.clamped( fg.var(i), x_i );
        clamped.WriteToFile( outfile );
        return 0;
    }
}
